> This page is for Unified.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.merge.dev/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.merge.dev/_mcp/server.

# /custom-object-classes/{id}

GET https://api.merge.dev/api/crm/v1/custom-object-classes/{id}

Returns a `CustomObjectClass` object with the given `id`.

Reference: https://docs.merge.dev/merge-unified/crm/custom-objects/custom-object-classes/retrieve

## Authentication

- `Authorization` header (bearer token, required) — Token-based authentication with required prefix "Bearer"

## Servers

- `https://api.merge.dev/api` (Production, default)
- `https://api-eu.merge.dev/api` (ProductionEU)
- `https://api-ap.merge.dev/api` (ProductionAPSE1)

## Request

### Path parameters

- `id` (string, required)

### Query parameters

- `expand` (list of enum, optional) — Which relations should be returned in expanded form. Multiple relation names should be comma separated without spaces.
  - Allowed values: `fields`
- `include_remote_data` (boolean, optional) — Whether to include the original data Merge fetched from the third-party to produce these models.
- `include_shell_data` (boolean, optional) — Whether to include shell records. Shell records are empty records (they may contain some metadata but all other fields are null).

### Headers

- `X-Account-Token` (string, required) — Token identifying the end user.

## Response

### 200

- `id` (string, optional)
- `remote_id` (string, optional, nullable) — The third-party API ID of the matching object.
- `created_at` (datetime, optional)
- `modified_at` (datetime, optional)
- `name` (string, optional, nullable) — The custom object class's name.
- `description` (string, optional, nullable) — The custom object class's description.
- `labels` (map from string to string, optional) — The custom object class's singular and plural labels.
- `fields` (list of RemoteFieldClassForCustomObjectClass, optional)
- `association_types` (list of map from string to any, optional, nullable) — The types of associations with other models that the custom object class can have.

## Types

### RemoteFieldClassForCustomObjectClass

- `created_at` (datetime, optional) — The datetime that this object was created by Merge.
- `modified_at` (datetime, optional) — The datetime that this object was modified by Merge.
- `display_name` (string, optional, nullable)
- `remote_key_name` (string, optional, nullable)
- `description` (string, optional, nullable)
- `is_required` (boolean, optional)
- `field_type` (enum, optional)
  - Allowed values: `string`, `number`, `date`, `datetime`, `bool`, `list`
- `field_format` (enum, optional)
  - Allowed values: `string`, `number`, `date`, `datetime`, `bool`, `list`
- `field_choices` (list of string, optional, nullable)
- `item_schema` (RemoteFieldClassForCustomObjectClassItemSchema, optional, nullable)

### RemoteFieldClassForCustomObjectClassItemSchema

- `item_type` (string, required, nullable)
- `item_format` (string, required, nullable)
- `item_choices` (list of string, required, nullable)

## Examples

**Response**

```json
{
  "id": "ff1ff4cb-a66b-47dc-8e2a-50388049e602",
  "remote_id": "9579977",
  "created_at": "2021-09-15T00:00:00Z",
  "modified_at": "2021-10-16T00:00:00Z",
  "name": "order",
  "description": "Order object",
  "labels": {
    "plural": "Orders",
    "singular": "Order"
  },
  "fields": [
    {
      "display_name": "Order ID",
      "remote_key_name": "order_id",
      "description": "The unique ID for the order.",
      "is_required": true,
      "field_type": "string",
      "field_format": "string",
      "field_choices": [],
      "item_schema": {
        "item_type": "string",
        "item_format": "string",
        "item_choices": [
          "string"
        ]
      },
      "is_nested_list": false
    },
    {
      "display_name": "Order Quantity",
      "remote_key_name": "order_quantity",
      "description": "The number of items ordered.",
      "is_required": true,
      "field_type": "number",
      "field_format": "number",
      "field_choices": [],
      "item_schema": {
        "item_type": "string",
        "item_format": "string",
        "item_choices": [
          "string"
        ]
      },
      "is_nested_list": false
    },
    {
      "display_name": "Customer Type",
      "remote_key_name": "customer_type",
      "description": "The type of customer.",
      "is_required": true,
      "field_type": "string",
      "field_format": "string",
      "field_choices": [
        "New",
        "Returning"
      ],
      "item_schema": null,
      "is_nested_list": false
    }
  ],
  "association_types": [
    {}
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.merge.dev/api/crm/v1/custom-object-classes/id"

querystring = {"include_remote_data":"true"}

headers = {
    "X-Account-Token": "X-Account-Token",
    "Authorization": "Bearer <token>"
}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true';
const options = {
  method: 'GET',
  headers: {'X-Account-Token': 'X-Account-Token', Authorization: 'Bearer <token>'}
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("X-Account-Token", "X-Account-Token")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["X-Account-Token"] = 'X-Account-Token'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true")
  .header("X-Account-Token", "X-Account-Token")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'X-Account-Token' => 'X-Account-Token',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true");
var request = new RestRequest(Method.GET);
request.AddHeader("X-Account-Token", "X-Account-Token");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Account-Token": "X-Account-Token",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.merge.dev/api/crm/v1/custom-object-classes/id?include_remote_data=true")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```